{*******************************************************}
{                                                       }
{       TDropFileListBox V1.00 Component                }
{                                                       }
{       Copyright (c) 2000.5 by Shen Min, Sunisoft      }
{                                                       }
{       Email: sunisoft@21cn.com                        }
{                                                       }
{       Web: http://sunisoft.126.com                    }
{                                                       }
{*******************************************************}

unit DropFileListBox;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ShellApi;

type
  TMyNotifyEvent = procedure (Sender: TObject;FileNames:TStringList) of object;
  TDropFileListBox = class(TListBox)
  private
    { Private declarations }
    FVersion:ShortString;
    FV:ShortString;
    FEnabled:Boolean;
    FCopyright:TStringList;
  protected
    FDropFile:TMyNotifyEvent;
    procedure DropFiles(var Mes:TMessage);message WM_DROPFILES;
    procedure FDropEnabled(Enabled:Boolean);
    procedure ShowCopyright(const Copy:TStringList);
    { Protected declarations }
  public
    constructor Create(AOwner: TComponent);override;
    destructor Destroy;override;
    { Public declarations }
  published
    property OnDropFiles:TMyNotifyEvent read FDropFile write FDropFile;
    property DropEnabled:Boolean read FEnabled write FDropEnabled;
    property Version:ShortString read FVersion write FV;
    property Copyright:TStringList read FCopyright write ShowCopyright;
    { Published declarations }
  end;

procedure Register;

implementation

procedure Register;
begin
  RegisterComponents('Sunisoft', [TDropFileListBox]);
end;

constructor TDropFileListBox.Create(AOwner: TComponent);
begin
inherited Create(AOwner);
FEnabled:=true;
FVersion:='V1.00';
FCopyright:=TStringList.Create;
FCopyright.Add('TDropFileListBox v1.00  Built at 2000.5.8');
FCopyright.Add(' ');
FCopyright.Add('    ߣF(Shen Min), ');
FCopyright.Add('    Email: sunisoft@21cn.com');
FCopyright.Add('    Web: http://sunisoft.126.com');
FCopyright.Add(' ');
FCopyright.Add('(c)Copyright 2000.5 by Shen Min, Sunisoft');
end;

destructor TDropFileListBox.Destroy;
begin
  FCopyright.Free;
  inherited Destroy;
end;


procedure TDropFileListBox.FDropEnabled(Enabled:Boolean);
begin
  FEnabled:=Enabled;
  DragAcceptFiles(self.handle,Enabled);
end;

procedure TDropFileListBox.DropFiles(var Mes:TMessage);
var FN:TStringList;
    FileName:array [1..256] of char;
    sFN:String;
    i,Count,p:integer;
begin
  FN:=TStringList.Create;
  Count:=DragQueryFile(mes.WParam,$FFFFFFFF,@FileName,256);
  For i:=0 to Count-1 do
    begin
      DragQueryFile(mes.WParam,i,@FileName,256);
      sFN:=FileName;
      p:=pos(chr(0),sFN);
      sFN:=copy(sFN,1,p-1);
      FN.Add(sFN);
    end;
  DragFinish(mes.WParam);
  if Assigned(FDropFile) then
    FDropFile(self, FN);
  FN.Free;
end;

procedure TDropFileListBox.ShowCopyright(const Copy:TStringList);
begin
//empty procudure
end;

end.
